-- AMS actions can be used here
WindowsButton = {}

WindowsButton.IsString = function(_i,_v)
	if (type(_v) ~= "string") then
		local strErrorMsg = Debug.GetSyntaxErrorString("Argument (".._i..") Must Be A String");
		if(type(error) == "function") then
			error(strErrorMsg);
		else
			Dialog.Message("Error",strErrorMsg, MB_OK, MB_ICONEXCLAMATION);
		end
		return false;
	end
	return true;
end

WindowsButton.SetText = function(strObjectName,strText)
	
	if not WindowsButton.IsString(1,strObjectName) then
		return;
	elseif not WindowsButton.IsString(2,strText) then
		return;
	end

	Application.ResetLastError();
	local nLastError = 0;

	local pObject = __Object.GetObjectPtr(strObjectName);
	if (pObject ~= 0) then
		__Object.CallFunction(pObject,"SetText",{strText});
	else
		nLastError = 100; -- object not found
	end
	Application.SetLastError(nLastError);
end

WindowsButton.GetText = function(strObjectName)
	local strResult = "";
	if not WindowsButton.IsString(1,strObjectName) then
		return strResult;
	end

	Application.ResetLastError();
	local nLastError = 0;

	local pObject = __Object.GetObjectPtr(strObjectName);
	if (pObject ~= 0) then
		strResult = __Object.CallFunction(pObject,"GetText",{});
	else
		nLastError = 100; -- object not found
	end

	Application.SetLastError(nLastError);

	return strResult;
end