-- Plugin specific definitions

tblEvents 				= {}
tblEvents[1] 			= {"On Click",""};


tblProperties 			= {}
tblProperties[1] 		= "Text"; 	-- button text
tblProperties[2] 		= 1; 		-- vertical text align : 0|top 1|center 2|bottom
tblProperties[3] 		= 1; 		-- horizontal text align : 0|left 1|center 2|right
tblProperties[4] 		= 0; 		-- multiline text

strPropertyDelimiter 	= "||"; 	-- can be anything else

nPropertiesDlgWidth 	= 350;
nPropertiesDlgHeight 	= 240;


m_hWnd 					= 0;
m_hMainHWnd				= 0;
m_hMainWndProc			= 0;
m_cbMainWndProc			= 0;
m_cbPropsDlgProc		= 0;

m_InstanceHandle	 	= 0;
m_ObjectPtr 			= 0;

IDCANCEL 				= 0;
IDOK 					= 1;
IDHELP 					= 2;
ID_EDIT_BUTTONTEXT 		= 100;
ID_COMBO_VTEXT_ALIGN 	= 101;
ID_COMBO_HTEXT_ALIGN 	= 102;
ID_CHECKBOX_MULTILINE 	= 103;

GWL_WNDPROC     		= -4;
WS_CHILD 				= 0x40000000;
WS_VISIBLE 				= 0x10000000;
WS_DISABLED 			= 0x08000000;
WS_BORDER				= 0x00800000;
WS_EX_CLIENTEDGE		= 0x00000200;

SS_RIGHT				= 0x00000002;

BS_PUSHBUTTON 			= 0x00000000;
BS_LEFT             	= 0x00000100;
BS_RIGHT            	= 0x00000200;
BS_CENTER           	= 0x00000300;
BS_TOP              	= 0x00000400;
BS_BOTTOM           	= 0x00000800;
BS_VCENTER          	= 0x00000C00;
BS_PUSHLIKE         	= 0x00001000;
BS_MULTILINE        	= 0x00002000;
BS_CHECKBOX				= 0x00000002;
BS_AUTOCHECKBOX			= 0x00000003;
BS_NOTIFY				= 0x00004000;

CBS_DROPDOWNLIST		= 0x0003;
CBS_DISABLENOSCROLL		= 0x0800;
CBS_HASSTRINGS			= 0x0200;

CB_ADDSTRING			= 0x0143;
CB_SETCURSEL			= 0x014E;
CB_GETCURSEL			= 0x0147;


ES_WANTRETURN			= 0x1000;
ES_MULTILINE			= 0x0004;

WM_COMMAND				= 0x0111;
WM_INITDIALOG   		= 0x0110;
WM_CLOSE				= 0x0010;
WM_SETFONT				= 0x0030;
WM_GETFONT				= 0x0031;


-- WinButton messages
BN_CLICKED				= 0;
BN_PAINT				= 1;
BN_HILITE				= 2;
BN_UNHILITE				= 3;
BN_DISABLE				= 4;
BN_DOUBLECLICKED		= 5;
BN_SETFOCUS				= 6;
BN_KILLFOCUS			= 7;

BM_GETCHECK				= 0x00F0;
BM_SETCHECK				= 0x00F1;

SW_HIDE 				= 0;
SW_SHOW 				= 5;
FALSE 					= 0;
TRUE 					= 1;
LOWORD					= function(nVal) return __Memory.BitAnd(nVal,0xffff); end
HIWORD					= function(nVal) return __Memory.RightShift(nVal,16); end
LONGBOOL 				= function(nVal) return (nVal > 0) end

-- define a RECT struct 
RECT = __Memory.CreateStruct(
	_int, "left",
	_int, "top",
	_int, "right",
	_int, "bottom");

-- import functions from user32.dll which we will use in our plugin 

User32 = __DLL.LoadLibrary("user32.dll", "stdcall");

if(User32) then

	CreateWindowEx 		= __DLL.GetFunction(User32,_int, "CreateWindowExA",_int,_string,_string,_int,_int,_int,_int,_int,_int,_int,_int,_int);
	MoveWindow 			= __DLL.GetFunction(User32,_int, "MoveWindow",_int,_int,_int,_int,_int,_int);
	DestroyWindow 		= __DLL.GetFunction(User32,_int, "DestroyWindow",_int);
	ShowControl 		= __DLL.GetFunction(User32,_int, "ShowWindow",_int,_int);
	SetFocus 			= __DLL.GetFunction(User32,_int, "SetFocus");
	IsWindow 			= __DLL.GetFunction(User32,_int, "IsWindow",_int);
	CallWindowProc 		= __DLL.GetFunction(User32,_int, "CallWindowProcA",_int,_int,_int,_int,_int);
	GetWindowLong 		= __DLL.GetFunction(User32,_int, "GetWindowLongA",_int,_int);
	SetWindowLong 		= __DLL.GetFunction(User32,_int, "SetWindowLongA",_int,_int,_callback);
	SetWindowLongPtr 	= __DLL.GetFunction(User32,_int, "SetWindowLongA",_int,_int,_int);
	SetWindowText 		= __DLL.GetFunction(User32,_int, "SetWindowTextA",_int,_string);

	GetWindowTextLength = __DLL.GetFunction(User32,_int, "GetWindowTextLengthA",_int);
	GetWindowText 		= __DLL.GetFunction(User32,_int, "GetWindowTextA",_int,__Memory.NewArray(_char),_int);

	MessageBox 			= __DLL.GetFunction(User32,_int, "MessageBoxA",_int,_string,_string,_int);

	GetWindowRect 		= __DLL.GetFunction(User32,_int, "GetWindowRect",_int,__Memory.NewArray(RECT));
	GetClientRect 		= __DLL.GetFunction(User32,_int, "GetClientRect",_int,__Memory.NewArray(RECT));
	DialogBox 			= __DLL.GetFunction(User32,_int, "DialogBoxParamA",_int,_string,_int,_callback,_int);
	EndDialog 			= __DLL.GetFunction(User32,_int, "EndDialog",_int,_int);
	GetDlgItem 			= __DLL.GetFunction(User32,_int, "GetDlgItem",_int,_int);

	GetActiveWindow 	= __DLL.GetFunction(User32,_int, "GetActiveWindow");
	GetParent 			= __DLL.GetFunction(User32,_int, "GetParent",_int);
	GetDesktopWindow 	= __DLL.GetFunction(User32,_int, "GetDesktopWindow");
	SendMessage 		= __DLL.GetFunction(User32,_int, "SendMessageA",_int,_int,_string,_string);
	SendMessageN 		= __DLL.GetFunction(User32,_int, "SendMessageA",_int,_int,_int,_int);
end

Kernel32 = __DLL.LoadLibrary("kernel32.dll", "stdcall");

if(Kernel32) then
	GetModuleHandle = __DLL.GetFunction(Kernel32,_int, "GetModuleHandleA",_string);
end

-- end of imports

-- User defined functions



function SetPropertiesDlgSize(hWnd)
	rcClient = {{left = 0,top = 0,right = 0,bottom = 0}};
	rcWindow = {{left = 0,top = 0,right = 0,bottom = 0}};
	GetClientRect(hWnd,rcClient);
	GetWindowRect(hWnd,rcWindow);
	local nVspace = (rcWindow[1].right-rcWindow[1].left) - (rcClient[1].right-rcClient[1].left); 
	local nHspace = (rcWindow[1].bottom-rcWindow[1].top) - (rcClient[1].bottom-rcClient[1].top);
	local x = rcWindow[1].left;
	local y = rcWindow[1].top;
	local w = nPropertiesDlgWidth + nVspace;
	local h = nPropertiesDlgHeight + nHspace;
	MoveWindow(hWnd,x,y,w,h,TRUE);
	
end
function UpdateProperties(hWnd)

	local nLength = GetWindowTextLength(GetDlgItem(hWnd,ID_EDIT_BUTTONTEXT));
	local buffer = __Memory.StringToChararray(string.rep("\0",nLength+1));
	GetWindowText(GetDlgItem(hWnd,ID_EDIT_BUTTONTEXT),buffer,nLength+1);
	tblProperties[1] = __Memory.ChararrayToString(buffer);
	tblProperties[2] = SendMessageN(GetDlgItem(hWnd,ID_COMBO_VTEXT_ALIGN),CB_GETCURSEL,0,0);
	tblProperties[3] = SendMessageN(GetDlgItem(hWnd,ID_COMBO_HTEXT_ALIGN),CB_GETCURSEL,0,0);
	tblProperties[4] = SendMessageN(GetDlgItem(hWnd,ID_CHECKBOX_MULTILINE),BM_GETCHECK,0,0);

end
function SetupPropertiesDlg(hWnd)

	SetWindowText(hWnd,"Windows Button Properties");

	local hWndParent = GetParent(hWnd);
	local hFont = SendMessageN(hWndParent,WM_GETFONT,0,0);
	local hWndControl = 0;
	

	local nTop = 10;
	local nMargin = 10;
	local nMargin2 = nMargin*2;
	
	hWndControl = CreateWindowEx(0, "STATIC", "Button Text :",WS_CHILD+WS_VISIBLE, nMargin,nMargin, nPropertiesDlgWidth-nMargin2,20,hWnd,0, 0, 0);
	SendMessageN(hWndControl,WM_SETFONT,hFont,0);
	nTop = nTop + nMargin + 20;
	
	local nEditStyle = WS_CHILD+WS_VISIBLE+ES_WANTRETURN+ES_MULTILINE;
	hWndControl = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", tostring(tblProperties[1]),nEditStyle, nMargin, nTop, nPropertiesDlgWidth-nMargin2,50,hWnd, ID_EDIT_BUTTONTEXT, 0, 0);
	SendMessageN(hWndControl,WM_SETFONT,hFont,0);

	nTop = nTop + nMargin + 50; 
	hWndControl = CreateWindowEx(0, "STATIC", "Vertical Text Align:",WS_CHILD+WS_VISIBLE, nMargin,nTop+3, (nPropertiesDlgWidth/2)-nMargin2,25,hWnd,0, 0, 0);	
	SendMessageN(hWndControl,WM_SETFONT,hFont,0);

	local nComboStyle = WS_CHILD+WS_VISIBLE+CBS_DROPDOWNLIST+CBS_DISABLENOSCROLL;

	hWndControl = CreateWindowEx(0, "COMBOBOX","",nComboStyle, (nPropertiesDlgWidth/2)+nMargin, nTop, (nPropertiesDlgWidth/2)-nMargin2,25,hWnd,ID_COMBO_VTEXT_ALIGN, 0, 0);
	SendMessage(hWndControl,CB_ADDSTRING,"","Top");
	SendMessage(hWndControl,CB_ADDSTRING,"","Center");
	SendMessage(hWndControl,CB_ADDSTRING,"","Bottom");
	SendMessageN(hWndControl,CB_SETCURSEL,tonumber(tblProperties[2]),0);
	SendMessageN(hWndControl,WM_SETFONT,hFont,0);

	nTop = nTop + nMargin + 25;
	hWndControl = CreateWindowEx(0, "STATIC", "Horizontal Text Align:",WS_CHILD+WS_VISIBLE, nMargin,nTop+3, (nPropertiesDlgWidth/2)-nMargin2,25,hWnd,0, 0, 0);
	SendMessageN(hWndControl,WM_SETFONT,hFont,0);
	
	hWndControl = CreateWindowEx(0, "COMBOBOX","",nComboStyle,(nPropertiesDlgWidth/2)+nMargin, nTop, (nPropertiesDlgWidth/2)-nMargin2,25,hWnd,ID_COMBO_HTEXT_ALIGN, 0, 0);
	SendMessage(hWndControl,CB_ADDSTRING,"","Left");
	SendMessage(hWndControl,CB_ADDSTRING,"","Center");
	SendMessage(hWndControl,CB_ADDSTRING,"","Right");
	SendMessageN(hWndControl,CB_SETCURSEL,tonumber(tblProperties[3]),0);
	SendMessageN(hWndControl,WM_SETFONT,hFont,0);

	nTop = nTop + nMargin + 25;
	hWndControl = CreateWindowEx(0, "BUTTON", "Multiline Text", WS_CHILD+WS_VISIBLE+BS_AUTOCHECKBOX, nMargin, nTop, nPropertiesDlgWidth-nMargin2,25,hWnd, ID_CHECKBOX_MULTILINE, 0, 0);
	SendMessageN(hWndControl,BM_SETCHECK,tonumber(tblProperties[4]),0);
	SendMessageN(hWndControl,WM_SETFONT,hFont,0);

    nTop = nTop + nMargin + 25;
	local nButtonWidth = ((nPropertiesDlgWidth-(nMargin*4))/3);
	hWndControl = CreateWindowEx(0, "BUTTON", "Help", WS_CHILD+WS_VISIBLE+BS_PUSHBUTTON+BS_NOTIFY, nMargin, nTop, nButtonWidth,25,hWnd, IDHELP, 0, 0);
	SendMessageN(hWndControl,WM_SETFONT,hFont,0);
	hWndControl = CreateWindowEx(0, "BUTTON", "Cancel", WS_CHILD+WS_VISIBLE+BS_PUSHBUTTON+BS_NOTIFY, nButtonWidth+nMargin*2, nTop, nButtonWidth,25,hWnd, IDCANCEL, 0, 0);
	SendMessageN(hWndControl,WM_SETFONT,hFont,0);
	hWndControl = CreateWindowEx(0, "BUTTON", "OK", WS_CHILD+WS_VISIBLE+BS_PUSHBUTTON+BS_NOTIFY, nButtonWidth*2+nMargin*3, nTop, nButtonWidth,25,hWnd, IDOK, 0, 0);
	SendMessageN(hWndControl,WM_SETFONT,hFont,0);

end

-- callback functions (expressed as C CallBack functions)
function MainWndProc(hWnd,message,wParam,lParam)

	if (message == WM_COMMAND) then
		if (lParam == m_hWnd) then
			local wmId = LOWORD(wParam); 
			local wmEvent = HIWORD(wParam); 

			if (wmEvent == BN_CLICKED) then
				__Object.FireEvent(m_ObjectPtr,"On Click","");
				return 1;
			end
		end
	end
	-- if we are not interested in with the message then forward it to main window
	return CallWindowProc(m_hMainWndProc,hWnd,message,wParam,lParam);
end

function PropertiesDlgProc(hWnd,message,wParam,lParam)

	if (message == WM_INITDIALOG) then
		SetPropertiesDlgSize(hWnd);
		SetupPropertiesDlg(hWnd);
		return TRUE;
	elseif (message == WM_CLOSE) then
		EndDialog(hWnd,0);
		return TRUE;
	elseif (message == WM_COMMAND) then
		local wmId = LOWORD(wParam); 
		local wmEvent = HIWORD(wParam); 
		if (wmEvent == BN_CLICKED) then
			if(wmId == IDOK) then
				UpdateProperties(hWnd);
				EndDialog(hWnd,IDOK);
				return TRUE;
			elseif(wmId == IDCANCEL) then
				EndDialog(hWnd,IDCANCEL);
				return TRUE;
			elseif(wmId == IDHELP) then
				--ShowHelp()
				return TRUE;
			end
		end
	end
	return FALSE;
end

-- SDK functions which will be called by host application
 
function OnCreateObject(ObjectPtr,InstanceHandle)
	m_InstanceHandle = InstanceHandle;
	m_ObjectPtr = ObjectPtr;
end

function OnDeleteObject()
	if(LONGBOOL(m_hMainWndProc)) then
         SetWindowLongPtr(m_hMainHWnd,GWL_WNDPROC,m_hMainWndProc);
	end
	if (IsWindow(m_hWnd) == TRUE) then
		DestroyWindow(m_hWnd);
	end
end

function GetDefaultSize()
	return {100,30};
end

function IsWindowedObject()
	return true; -- yes this is a windowed object
end

function GetWindowHandle()
	return m_hWnd; -- return our control's window handle 
end

function DrawDesign(HDC,WndParent,X,Y,Width,Height,Visible,Enabled)
	-- this is design time that means we are in AMS IDE 
	-- and user is doing something with this object and object needs to be redrawed

	-- prepare button styles according the user's choices
	-- and make sure you disabled your control if this object is a windowed object
	local nStyle = BS_PUSHBUTTON + WS_CHILD + WS_DISABLED;
	
	if (Visible == true) then
		nStyle = nStyle + WS_VISIBLE;
	end
	--vertical text alignment
	if (tblProperties[2] == 0) then
		nStyle = nStyle + BS_TOP;
	elseif (tblProperties[2] == 1) then
		nStyle = nStyle + BS_VCENTER;
	elseif (tblProperties[2] == 2) then
		nStyle = nStyle + BS_BOTTOM;
	end
	--horizontal text alignment
	if( tblProperties[3] == 0) then
		nStyle = nStyle + BS_LEFT;
	elseif (tblProperties[3] == 1) then
		nStyle = nStyle + BS_CENTER;
	elseif (tblProperties[3] == 2) then
		nStyle = nStyle + BS_RIGHT;
	end
	if (tblProperties[4] == TRUE) then
		nStyle = nStyle + BS_MULTILINE;
	end


	if( CreateWindowEx) then
		if (IsWindow(m_hWnd) == FALSE) then -- create a button control if it was not created yet
			m_hWnd = CreateWindowEx(0, "BUTTON", tblProperties[1], nStyle,X,Y,Width,Height,WndParent, 0, 0, 0);
		else -- move/resize control if it is already created
			if (MoveWindow) then
				MoveWindow(m_hWnd,X,Y,Width,Height,TRUE);
			end
		end
	end
		
 
end

function DrawRuntime(HDC,WndParent,X,Y,Width,Height,Visible,Enabled)
	-- this is run time that means we are in actual application

	-- hook main window procedure to get notified when our control sends messages to it 
	-- Warning : do it only at runtime , and only once
	if (m_hMainWndProc == 0) then
		m_hMainWndProc = GetWindowLong(WndParent,GWL_WNDPROC);	
		if(LONGBOOL(m_hMainWndProc)) then
			m_cbMainWndProc = __DLL.NewCallback(User32,_int, MainWndProc,_int,_int,_int,_int);
			SetWindowLong(WndParent,GWL_WNDPROC,m_cbMainWndProc);
			m_hMainHWnd = WndParent;
		end
	end

	local nStyle = BS_PUSHBUTTON + WS_CHILD + BS_NOTIFY;
	if (Visible == true) then
		nStyle = nStyle + WS_VISIBLE;
	end
	if(Enabled == false) then
		nStyle = nStyle + WS_DISABLED;
	end

	if (CreateWindowEx) then
		if (IsWindow(m_hWnd) == FALSE) then
			m_hWnd = CreateWindowEx(0, "BUTTON", tblProperties[1], nStyle,X,Y,Width,Height,WndParent, 0, 0, 0);
		else
			if (MoveWindow) then
				MoveWindow(m_hWnd,X,Y,Width,Height,TRUE);
			end
		end
	end

end

function GetCustomProperties()
	-- IDE needs to store our object's custom properties in project file
	-- so , we should return custom properties to be stored in project 

	local strProperties = string.format("%s%s%d%s%d%s%d",tblProperties[1],strPropertyDelimiter,tblProperties[2],strPropertyDelimiter,tblProperties[3],strPropertyDelimiter,tblProperties[4]);
	return strProperties;
end

function SetCustomProperties(Properties)
	-- plugin properties needs to be updated
	-- host application has sent saved properties that we delivered on GetCustomProperties() call
	-- the 'Properties' argument contains the properties in delimited string form ,as we have setup

	-- a simple delimited string to table implementation to assign new properties to properties table

	local str = Properties;
	local t = {};
	local fpat = "(.-)" .. strPropertyDelimiter;
	local last_end = 1;
	local s, e, cap = str:find(fpat, 1);
	while s do
		if s ~= 1 or cap ~= "" then
			table.insert(t,cap);
		end
		last_end = e+1;
		s, e, cap = str:find(fpat, last_end);
	end
	if last_end <= #str then
		cap = str:sub(last_end);
		table.insert(t, cap)
	end
	if(#t == #tblProperties) then
		tblProperties[1] = tostring(t[1]);
		tblProperties[2] = tonumber(t[2]);
		tblProperties[3] = tonumber(t[3]);
		tblProperties[4] = tonumber(t[4]);
	end

end

function ShowProperties(PluginFolder)

	-- user has clicked to the properties button and wants to open properties dialog
	-- if you return false then nothing will happen in IDE

	-- create a call back function to attach window procedure of properties dialog
	-- so we can catch button click events and anything else we want to catch
	-- lua implementation of the 'PropertiesDlgProc' function is defined above

	m_cbPropsDlgProc = __DLL.NewCallback(User32,_int,PropertiesDlgProc,_int,_int,_int,_int);

	-- create a dialog box window  , its controls will be created 
	-- when WM_INITDIALOG message has sent to the window procedure of dialog box

	-- Note : a dialog template is required to create a dialog box and binary file of this plugin
	-- contains a template in its resource section that can be used , its resource ID is IDD_DIALOG_PROPERTIES

	local nResult = DialogBox(m_InstanceHandle,"IDD_DIALOG_PROPERTIES",GetActiveWindow(),m_cbPropsDlgProc,1);

	-- after creation of this dialog the 'PropertiesDlgProc' function will be called on every activity on the dialog

	return true;
end

function GetNumEvents()
	-- Note : you must implement at least one event for your object
	-- AMS IDE will crash when you click to script tab on object settings dialog if you will not do this
	return #tblEvents;
end

function GetEvent(Index)
	return tblEvents[Index];
end

function HideInternalObject()
	-- this function will be called when , for example a page jump occurs
	-- so this object should be destroyed or hidden ,it may vary on your plugin implementation
	-- bu usually you should destroy your control here if this plugin is a windowed object

	if (IsWindow(m_hWnd) == TRUE) then
		DestroyWindow(m_hWnd);
		m_hWnd = 0;
	end
end

function LetAMSHandleCursorChange()
	-- Let user to set a custom cursor for this object
	-- Note: works only if object is not windowed
	return false;
end

function LetAMSHandleSounds()
	-- Let user to set custom sounds for this object
	-- Note: works only if object is not windowed
	return false;
end

function LetAMSHandleTooltip()
	-- Let user to set tooltip text for this object
	-- Note: works only if object is not windowed
	return false;
end

function CanSetFocus()
	-- Can this object get mouse focus
	-- Note: works only if object is windowed

	-- yes can set focus
	return true;
end

function DoSetFocus()
	-- Set focus to your window or control
	-- Note: works only if object is windowed

	if (IsWindow(m_hWnd) == TRUE) then
		SetFocus(m_hWnd);
	end
end
	
function ShowWindow(Visible)
	-- Show or hide your window or control
	-- Note: works only if object is windowed

	if (IsWindow(m_hWnd) == TRUE) then
		if (Visible == true) then
			ShowControl(m_hWnd,SW_SHOW);
		else
			ShowControl(m_hWnd,SW_HIDE);
		end
	end
end

-- these are the functions to operate this plugin from lua functions module
-- __Object.CallFunction can be used to call these functions

function SetText(strText)
	if (IsWindow(m_hWnd) == TRUE) then
		tblProperties[1] = strText;
		SetWindowText(m_hWnd,strText);		
	end
end

function GetText()
	return tblProperties[1] or "";
end